<template>
  <i-wrapper top>
    <i-stepper :total="auth.onboarding.total" :filled="1" />
    <i-curtain tag="form" @submit="submit()">
      <img src="~assets/images/bubbles-orange.svg" class="bubbles bubbles--custom" />
      <img src="~assets/images/scientist-hello.png" class="scientist-hello" />
      <div class="title px-1 text-center">{{ $t(`For starters, let's get to know each other.`) }}</div>
      <div class="normal-text text-center px-1">{{ $t(`What can I call you?`) }}</div>
      <template #bottom>
        <i-input ref="nameInput" v-model="name" class="mb-1" :placeholder="$t(`Type your Name`)" />
        <i-button submit block :loading="isLoading" :disabled="isLoading">{{ $t(`CONTINUE`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',

    data() {
      return {
        name: this.$store.state.auth.onboarding.name,
        isLoading: false,
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    mounted() {
      if (this.$route.query.r) {
        ga('send', 'event', 'onb_1_name_redirected');
      }

      this.$nextTick(() => {
        this.$refs.nameInput.$refs.input.focus();
      });
    },

    methods: {
      async submit() {
        if (this.isLoading) {
          return;
        }

        console.log('SUBMIT');

        if (!this.name) {
          this.$refs.nameInput.$refs.input.focus();
          this.$refs.nameInput.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.nameInput.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`onboarding/name`, {
            name: this.name,
          });

          ga('send', 'event', 'onb_1_name');
          this.$store.commit('MERGE_AUTH', { onboarding: response.data.data, user: response.data.data.user });
          await this.$router.push(this.localePath({ name: 'onboarding.gender' }));
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss">
  .figures-colored {
    position: absolute;
    z-index: 0;
    top: rs(30px);
    right: rs(7px);
    width: rw(360px);
  }

  .scientist-hello {
    width: rw(106px);
    margin-top: rs(30px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    margin-top: rs(15px);
  }

  .normal-text {
    font-size: rf(16px);
    margin-top: rs(10px);
  }

  .shield-success {
    width: rw(46.8px);
    margin-top: rs(15px);
  }

  .bubbles--custom {
    top: rs(147px);
  }
</style>
